
# coding: utf-8

# <div style=" display: block; margin-top: 2em; margin-bottom: 2em; border-style: solid; border-color: #0051ba; border-width: 2px;"></div>
# 
# <table style="width:95%;">
#   <tr style="background-color: #fff; font-family:'Helvetica'; font-size:120%">
#     <td style="padding-right:2em;">
#         <img src="https://crmda.dept.ku.edu/images/logoleft.png" alt="left side logo" style="width:60; height:60;">
#     </td>
#     <td style="width:60%; text-align:left; ">
#         <h1 style="text-align:center;">Python Data Science</h1>
#         <h3 style="text-align:center;">Getting Started: The Very Basics of Python</h3>
#         <div style=" display: block; margin-top: 1em; margin-bottom: 1em; border-style: solid; border-width: 1px;"></div>
#         <span style="font-weight:bold;">Dr. Jonathan Lamb</span>, Faculty Fellow, CRMDA, <a class="author_email" href="mailto:#"> &lt;jonathanplamb@ku.edu&gt;</a><br><br>
#         <span style="font-weight:bold;">Keywords:</span> Python, Getting Started, Beginners
#     </td>
#     <td style="padding-left:2em;">
#     <img src="https://crmda.dept.ku.edu/images/logo-vert.png" alt="right side logo" style="width:60; height:60;">
#     </td>
# </tr>
# </table>
# 
# <div style=" display: block; margin-top: 2em; margin-bottom: 2em; border-style: solid; border-color: #0051ba; border-width: 2px;"></div>

# # Introduction to Python

# Welcome to Python Data Science!
# 
# The goal of this week's workshops is NOT to teach you everything about Python. Learning to code in Python, like learning any new skill, requires time and discipline. Rather, the goals are 1) to show you some of the nifty things Python can do, 2) to introduce you to methods of data analysis, and 3) to give you a crash course in Python literacy.
# 
# The scripts we will use this week are a mish-mash of new and borrowed scripts. Special thanks go to Ted Underwood, Geoffrey Rockwell and Stefan Sinclair, and the Berkeley Digital Humanities Lab.

# ## What is this thing I am looking at?

# Now that you have installed Anaconda, opened Jupyter Notebooks, and navigated to this file, you are inside a Jupyter Notebook. The notebook format allows you to write and run code, view the results of the code, and create commentary on the code and output. Jupyter Notebooks are especially useful for teaching, and for projects that do not involve creating standaone applications.
# 
# A notebook is composed of a series of <b>cells</b>. The cell you are reading now is called a <b>Markdown Cell</b>. These cells allow you to input text and mark it up with html, links, and other features. (If you want a full tour, click the "Help" menu above, then click "User Interface Tour."
# 
# Cells in which code appears is called a <b>Code Cell</b>. Hence their more programmy appearance.
# 
# Some commands to know:
# - To run a cell, select it by clicking inside it, then type <b>shift+enter</b>.
# - To create a new cell BELOW the cell you are working in, type <b>esc+b</b>.
# - To create a new cell ABOVE the cell you are working in, type <b>esc+a</b>.
# - To edit a Markdown cell, <b>double-click the cell.</b>
# - To write a comment in a code block, simply use the hastag character (#). This tells the computer to ignore text that follows.
# - If you have any questions as we go, just ask! 
# 

# ## Creating a new Notebook
# 
# To create a new notebook, simply click the _New_ button from the chosen directory page and selecting "Python 3" from the menu.
# 
# Doing this will create a new notebook with the name "Untitled." The file will be created in the directory where you last navigated on the Jupyter navigation window (the window that opened when you initialized the Notebook).
# 
# To rename the Notebook, click the name at the top of the page (next to the word "Jupyter"). Remember that you are renaming the file itself, so it's best to avoid spaces and alphanumeric characters.

# ## Some Basics of Python
# 
# Let's get started with some Python code. We won't spend too long going through the basics (since this is not a programming class). In many cases, there won't be extensive Markdown information about what we're doing in the Code, so consider annotating as we go in one of two ways. You can:
# 1. Create a new Markdown cell and write your own comments in it.
# 2. Comment in the code itself with a single-line comment (the # symbol)
# See samples below.

# In[ ]:


"Hello World!" # Prints the phrase "Hello World!"


# In[ ]:


print("Hello World!") # Also prints the phrase "Hello World!"


# One of the most basic and important concepts of programming in Python (and all programming!) is the ability to assign a value to a **variable**. Below, we create a string variable and then an integer.

# In[ ]:


greeting = "Hello World!"
print(greeting)


# In[ ]:


x = 2
print(x)


# We can operate on variables.

# In[ ]:


print(x * x)
print(greeting + greeting) # What happened here?


# In[ ]:


print(x==x)


# In[ ]:


print(x > 6)


# In[ ]:


banana = "Pride and Prejudice"


# In[ ]:


book = 'Pride and Prejudice'
print(banana, book)


# In Jupyter Notebooks, the memory 'kernel' saves the value of variables across cells, so if we run the next five cells, we will change the value of the ```number_of_books``` variable every time. Skipping one cell (or skipping the cell where we actually create the variable) will result in a different value, or an error.

# In[ ]:


number_of_books = 100


# In[ ]:


number_of_books = number_of_books + 1

# What happens if you run this cell multiple times?


# In[ ]:


number_of_books += 5


# In[ ]:


extra_books = 75


# In[ ]:


number_of_books += extra_books
print(number_of_books)


# #### Strings!
# Working with strings means knowing how to index them. The index of strings starts at 0 (zero).

# In[ ]:


# String concatenation
# Insert your name and favorite book between the quotation marks below.
name = ""
favorite_book = ""
print(name + " likes " + favorite_book + ".")


# In[ ]:


first_letter = name[0]
print(first_letter)


# In[ ]:


last_letter = name[7]
print(last_letter)


# In[ ]:


last_letter = name[-1] #Pointing to a particular position in a string is called INDEXING.
print(last_letter)


# In[ ]:


print(len(name)) # the len() command returns the length of a string.


# Can you write code that creates a variable and assigns to it the second-to-last letter of your name?

# In[ ]:


but_last_letter = #insert your code here, using the name variable you created earlier
print(but_last_letter)


# In[ ]:


first_two_letters = name[0:2] #This is called a slice index. 
print(first_two_letters)


# Play around with the slice index to see what configurations you can come up with.

# In[ ]:


print(name[0:2])
print(name[2:])
print(name[-2:])
print(name[(-len(name)):(-len(name)+3)])


# Given the following two words, can you write code that prints out the word **humanities** using only slicing and concatenation? (So, no quotes are allowed in your code.)

# In[ ]:


word1 = "human"
word2 = "opportunities"
# insert your code here


# ### Dynamic Content
# 
# You can also print dynamic content, such as the time.

# In[ ]:


import time
print(time.strftime("%c"))


# In[ ]:


print("Hello World! It's", time.strftime("%A %B %e, %Y"))


# In[ ]:


text = "Hello World! It's"
now = time.strftime("%A %B %e, %Y")
print(text, now)


# ## Lists
# Another important class of objects in Python is the **list**. A list is exactly what it sounds like: a series of objects. Any time you see ```[ ]``` chraracters, you're referring to a list. You can have nested lists (or a list of lists).

# In[ ]:


sentence = "Python's name is derived from the television series Monty Python's Flying Circus."


# In[ ]:


first_word = sentence[0]
print(first_word)


# In[ ]:


words = sentence.split()
print(words)


# In[ ]:


first_word = # What do we write here to assign this variable to the first word in the sentence?
print(first_word)


# In[ ]:


#start with an empty list
favorite_foods = []

#add items to the list using "append"
favorite_foods.append("Nutella crepes")
favorite_foods.append("Coffee")
print(favorite_foods)


# In[ ]:


favorite_foods[0] = "Banana Nutella crepes"
print(favorite_foods)


# In[ ]:


# We can also remove an item from the list using "remove"

favorite_foods.remove("Coffee")
print(favorite_foods)


# In[ ]:


# Just as we can concatenate strings, we can concatenate lists
good_reads = ["The Hunger games", "A Clockwork Orange", 
              "Pride and Prejudice", "Water for Elephants",
              "The Shadow of the Wind", "Bel Canto"]

bad_reads = ["Fifty Shades of Grey", "Twilight"]

all_reads = good_reads + bad_reads
print(all_reads)


# In[ ]:


#We can also sort the list
good_reads.sort()
print(good_reads)


# In[ ]:


#We can also nest lists. This is often useful when working with different data types.
nested_list = [[1, 2, 3, 4], [5, 6, 7, 8]]
print(nested_list[0])
print(nested_list[0][0])


# We can use nested lists to enhance our good read collection with a score for every book. An entry in our collection will consist of a score within the range of 1 and 10 and the title of our book. The first element is the title; the second the score: `[title, score]`.

# In[ ]:


good_reads = [] #Can anyone tell us why this line is bad programming practice?
good_reads.append(["Pride and Prejudice", 8])
good_reads.append(["Ulysses", 9])


# ## Combining what we've learned so far
# 
# Using the `input` feature, we can combine what we've learned to write a basic program that asks for input from the user and computes something.

# In[ ]:


# wordcounter
# A simple program that counts words.

sentence = input('Enter a sentence: ')
words = sentence.split(' ')
sentence_length = len(words)
print('That had ' + str(sentence_length) + ' words.')


# In[ ]:


# screamer
# A program that repeats whatever you say, a little louder.

quiet = input('yell something: ')
loud = quiet.upper()
print('Oh, did you say ' + loud + '?')


# ## Dictionaries

# Our little good reads collection is starting to look good and we can perform all kinds of manipulations on it. Now, imagine that our list is large and we would like to look up the score we gave to a particular book. How are we going to find that book? For this purpose, Python provides another more appropriate data structure, named `dictionary`. A `dictionary` is similar to the dictionaries you have at home. It consists of entries, or keys, that hold a value. Let's define one:

# In[ ]:


my_dict = {"book": "physical objects consisting of a number of pages bound together",
           "sword": "a cutting or thrusting weapon that has a long metal blade",
           "pie": "dish baked in pastry-lined pan often with a pastry top"}


# Take a close look at the new syntax. Notice the curly brackets and the colons. Keys are located at the left side of the colon; values at the right side. To look up the value of a given key, we 'index' the dictionary using that key:

# In[ ]:


description = my_dict["sword"]
print(description)


# In[ ]:


good_reads = {}
good_reads["Pride and Prejudice"] = 8
good_reads["Ulysses"] = 9


# In[ ]:


good_reads.keys()


# In[ ]:


good_reads.values()


# ## Conditions

# In[ ]:


print("2 < 5 =", 2 < 5)
print("3 > 7 =", 3 >= 7)
print("3 == 4 =", 3 == 4)
print("school == homework =", "school" == "homework")
print("Python != R =", "Python" != "R")


# ### if, elif, and else

# In[ ]:


good_reads["A Room of One's Own"]


# In[ ]:


book = "Ulysses"
if book in good_reads:
    print(book + " is in the collection")
    print("A lot more")
    print("Still more to come")
else:
    print(book + " is NOT in the collection")


# ### Indentation!
# 
# Before we continue, we must first explain to you that the layout of the code is not optional. Unlike in other languages, Python does not make use of curly braces to mark the start and end of expressions. The only delimiter is a colon (`:`) and the indentation of the code. This indentation must be used consistently throughout your code. The convention is to use 4 spaces as indentation. This means that after you have used a colon (such as in our `if` statement) the next line should be indented by four spaces more than the previous line.
# 
# Sometimes, we have various conditions that should all evaluate to something different. For that Python provides the `elif` statement. We use it similar to `if` and `else`. (Note, however, that you can only use `elif` after an `if` statement.) Above, we asked whether a book was in the collection. We can do the same thing for parts of strings or for items in a list. For example we could test whether the letter *a* is in the word *banana*:

# In[ ]:


"a" in "banana"


# In[ ]:


"z" in "banana"


# In[ ]:


word = "amoebic dysentery"
if "a" in word:
    print(word + " contains the letter a")
elif "s" in word:
    print(word + " contains the letter s")
else:
    print("What a weird word!")


# Note that something went wrong in the cell above. What was it? How can we fix it? Try to change the code in the cell below.

# In[ ]:


word = "amoebic dysentery"
if "a" in word:
    print(word + " contains the letter a")
elif "s" in word:
    print(word + " contains the letter s")
else:
    print("What a weird word!")


# In[ ]:


word = "banana"
if "a" in word and "b" in word:
    print("Both a and b are in " + word)


# In[ ]:


if "a" in word and "z" in word:
    print("Both a and z are in " + word)


# In[ ]:


#Can you make the script print "Both letters not found" if both letters weren't found?

if "a" in word and "z" in word:
    print("Both a and z are in " + word)
# insert your code here


# Objects (i.e., strings or integers of lists) are `True` because they exist. Empty strings, lists, and dictionaries are `False` because they do *not* exist. We can use this principle to execute a piece of code only if a certain list contains any values:

# In[ ]:


numbers = [1, 2, 3, 4]
if numbers:
    print("I found some numbers!")


# In[ ]:


numbers = []
if numbers:
    print("I found some numbers!")


# Can you write code that uses the `len()` function and conditionals to print "The list is empty!" if the list is empty and, if the list is not empty, to print how many items are in the list?

# In[ ]:


numbers = []
#More code here


# ## Loops!
# Working with data in Python often involves looping through data structures--lists, etc. There are several ways to accomplish looping:

# In[ ]:


# A simple 'for' loop.
for letter in "banana":
    print(letter)


# In[ ]:


# You can loop through lists, like this.
colors = ["yellow", "red", "green", "blue", "purple"]
for whatever in colors:
    print("This is color " + whatever)


# In[ ]:


# You can loop through dictionaries, like this.
for book in good_reads:
    print(book)


# In[ ]:


# You can also loop through items in a dictionary
for x, y in good_reads.items():
    print(x + " has score " + str(y))


# #### List Comprehensions!
# 
# One of Python's most versatile and compact functions is called a **list comprehension**. It takes this form:
# 
#     [expression for item in list]
# 
# The idea is that we can iterate over any iterable data. The ```expression``` can be anything, even transformed data. The ```list``` can be any iterable data. **Note: a list comprehension must be surrounded with square brackets.** Thus, we can iterate over our ```colors``` list above:

# In[ ]:


print(colors)
print([color for color in colors])


# In[ ]:


upper_case_colors = [color.upper() for color in colors]
print(upper_case_colors)


# In[ ]:


colors_with_ls = [color for color in colors if 'l' in color]
print(colors_with_ls)


# ## What's the point?
# The point of running through these data structures and types is that they form the basis of working with data in Python. For instance, we can combine a loop and a conditional structure, as below.

# In[ ]:


title = input('Enter a book title: ')
score = input('What score did you give it (between 0 and 10)')
good_reads.update({title: int(score)})
print(good_reads)


# In[ ]:


for x, y in good_reads.items():
    if y > 8:
        print(x, "was a good book! It scored", y, "on your rating system.")
    else:
        print(x, "was not so good. It only scored", y, "on your rating system.")


# ## What to expect next:
# - We will be building on this basic knowledge as we begin to discuss how to use Python to explore and analyze data sets.
# - This DEFINITELY DOES NOT cover all of the basics of Python.
# - We will be learning more of the basics as we go.
# - Onward to Exploratory Data Analysis!

# # But wait! How to close your Jupyter Notebook.
# Closing the Jupyter notebook requires a couple of steps:
# 1. Click above on "File" and click "Save and Checkpoint."
# 2. Click "Close and Halt." This will close this window.
# 3. On the Jupyter navigation window, click "Logout."
# 4. In your Terminal/Command Line window, you will see that the memory kernel is still open. To close it, type CTRL + C, then type CTRL + C again.
